require 'spec_helper'

module Quby::Compiler
  describe DSL do
    describe '.build_from_definition' do
      let(:repo) { Quby.send(:questionnaire_repo) }
      it 'builds a questionnaire from a definition' do
        definition = Entities::Definition.new(key: 'test', sourcecode: "", path: "")
        expect(described_class.build_from_definition(definition)).to be_instance_of(Entities::Questionnaire)
      end

      it 'uses a path on instance eval, so we get correct stack traces' do
        definition = Quby::Compiler::Entities::Definition.new(key: 'test',
                                                                    sourcecode: 'raise("problem")',
                                                                    path: 'spec/fixtures/raising.rb')
        expected_backtrace = include(end_with("spec/fixtures/raising.rb:1:in `block in build_from_definition'"))
        expect { described_class.build_from_definition(definition) }.to \
          raise_exception(having_attributes(backtrace: expected_backtrace))
      end
    end
  end
end
